/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef JAC_AP_CAMERADRIVINGPERSERVICE_CAMERADRIVINGPERCEPTIONSERVICE_PROXY_H
#define JAC_AP_CAMERADRIVINGPERSERVICE_CAMERADRIVINGPERCEPTIONSERVICE_PROXY_H

#include "ara/com/internal/proxy/proxy_adapter.h"
#include "ara/com/internal/proxy/event_adapter.h"
#include "ara/com/internal/proxy/field_adapter.h"
#include "ara/com/internal/proxy/method_adapter.h"
#include "ara/com/crc_verification.h"
#include "jac/ap/cameradrivingperservice/cameradrivingperceptionservice_common.h"
#include <string>

namespace jac {
namespace ap {
namespace cameradrivingperservice {
namespace proxy {
namespace events {
    using CameraDrvPerception2FusionEvent = ara::com::internal::proxy::event::EventAdapter<::perception::vector_CameraPerception2Fusion>;
    static constexpr ara::com::internal::EntityId CameraDrivingPerceptionServiceCameraDrvPerception2FusionEventId = 12155U; //CameraDrvPerception2FusionEvent_event_hash
}

namespace fields {
}

namespace methods {

} // namespace methods

class CameraDrivingPerceptionServiceProxy {
private:
    std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> proxyAdapter;
public:
    using HandleType = ara::com::HandleType;
    class ConstructionToken {
    public:
        explicit ConstructionToken(const std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> & proxy)
            : proxyAdapter(proxy),
              CameraDrvPerception2FusionEvent(proxyAdapter->GetProxy(), events::CameraDrivingPerceptionServiceCameraDrvPerception2FusionEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()){
        }

        ConstructionToken(ConstructionToken&& other) = default;
        ConstructionToken& operator=(ConstructionToken && other) = default;

        ConstructionToken(const ConstructionToken&) = delete;
        ConstructionToken& operator = (const ConstructionToken&) = delete;
        
        virtual ~ConstructionToken() = default;

        /* Do not use such internal interfaces!!! */
        ara::core::Result<void> InitializeAll()
        {
            ara::core::Result<void> initResult;
            return initResult;
        }
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> GetProxyAdapter()
        {
            return proxyAdapter;
        }
        events::CameraDrvPerception2FusionEvent GetCameraDrvPerception2FusionEvent() noexcept { return std::move(CameraDrvPerception2FusionEvent); }
    private:
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> proxyAdapter;
        events::CameraDrvPerception2FusionEvent CameraDrvPerception2FusionEvent;
    };

    virtual ~CameraDrivingPerceptionServiceProxy()
    {
        CameraDrvPerception2FusionEvent.UnsetReceiveHandler();
        CameraDrvPerception2FusionEvent.Unsubscribe();

    }

    explicit CameraDrivingPerceptionServiceProxy(const HandleType &handle)
        : proxyAdapter(std::make_shared<ara::com::internal::proxy::ProxyAdapter>(::jac::ap::cameradrivingperservice::CameraDrivingPerceptionService::ServiceIdentifier, handle)),
          CameraDrvPerception2FusionEvent(proxyAdapter->GetProxy(), events::CameraDrivingPerceptionServiceCameraDrvPerception2FusionEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()){
        }

    void ThrowError(const ara::core::Result<void>& result) const
    {
        if (!(result.HasValue())) {
#ifndef NOT_SUPPORT_EXCEPTIONS
            ara::core::ErrorCode errorcode(result.Error());
            throw ara::com::ComException(std::move(errorcode));
#else
            std::cerr << "Error: Not support exception, create proxy failed!"<< std::endl;
#endif
        }
    }

    CameraDrivingPerceptionServiceProxy(const CameraDrivingPerceptionServiceProxy&) = delete;
    CameraDrivingPerceptionServiceProxy& operator=(const CameraDrivingPerceptionServiceProxy&) = delete;

    CameraDrivingPerceptionServiceProxy(CameraDrivingPerceptionServiceProxy&&) = default;
    CameraDrivingPerceptionServiceProxy& operator=(CameraDrivingPerceptionServiceProxy&&) = default;
    CameraDrivingPerceptionServiceProxy(ConstructionToken&& token) noexcept
        : proxyAdapter(token.GetProxyAdapter()),
          CameraDrvPerception2FusionEvent(token.GetCameraDrvPerception2FusionEvent()){
        static_cast<void>(std::move(token));
    }

    static ara::core::Result<ConstructionToken> Preconstruct(
        const ara::com::HandleType &handle)
    {
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> preProxyAdapter =
            std::make_shared<ara::com::internal::proxy::ProxyAdapter>(
               ::jac::ap::cameradrivingperservice::CameraDrivingPerceptionService::ServiceIdentifier, handle);
        ConstructionToken token{std::move(preProxyAdapter)};
        ara::core::Result<void> initResult {token.InitializeAll()};
        if (initResult.HasValue()) {
            return ara::core::Result<ConstructionToken>(std::move(token));
        } else {
            const ara::core::ErrorCode errorcode{initResult.Error()};
            ara::core::Result<CameraDrivingPerceptionServiceProxy::ConstructionToken> preResult{errorcode};
            return preResult;
        }
    }

    static ara::com::FindServiceHandle StartFindService(
        const ara::com::FindServiceHandler<ara::com::internal::proxy::ProxyAdapter::HandleType>& handler,
        const ara::com::InstanceIdentifier instance)
    {
        return ara::com::internal::proxy::ProxyAdapter::StartFindService(handler, ::jac::ap::cameradrivingperservice::CameraDrivingPerceptionService::ServiceIdentifier, instance);
    }

    static ara::com::FindServiceHandle StartFindService(
        const ara::com::FindServiceHandler<ara::com::internal::proxy::ProxyAdapter::HandleType> handler,
        const ara::core::InstanceSpecifier specifier)
    {
        return ara::com::internal::proxy::ProxyAdapter::StartFindService(handler, ::jac::ap::cameradrivingperservice::CameraDrivingPerceptionService::ServiceIdentifier, specifier);
    }

    static ara::com::ServiceHandleContainer<ara::com::internal::proxy::ProxyAdapter::HandleType> FindService(
        const ara::com::InstanceIdentifier instance)
    {
        return ara::com::internal::proxy::ProxyAdapter::FindService(::jac::ap::cameradrivingperservice::CameraDrivingPerceptionService::ServiceIdentifier, instance);
    }

    static ara::com::ServiceHandleContainer<ara::com::internal::proxy::ProxyAdapter::HandleType> FindService(
        const ara::core::InstanceSpecifier specifier)
    {
        return ara::com::internal::proxy::ProxyAdapter::FindService(::jac::ap::cameradrivingperservice::CameraDrivingPerceptionService::ServiceIdentifier, specifier);
    }

    static void StopFindService(const ara::com::FindServiceHandle& handle)
    {
        ara::com::internal::proxy::ProxyAdapter::StopFindService(handle);
    }

    HandleType GetHandle() const
    {
        return proxyAdapter->GetHandle();
    }
    bool SetEventThreadNumber(const std::uint16_t number, const std::uint16_t queueSize)
    {
        return proxyAdapter->SetEventThreadNumber(number, queueSize);
    }
    events::CameraDrvPerception2FusionEvent CameraDrvPerception2FusionEvent;
};
} // namespace proxy
} // namespace cameradrivingperservice
} // namespace ap
} // namespace jac

#endif // JAC_AP_CAMERADRIVINGPERSERVICE_CAMERADRIVINGPERCEPTIONSERVICE_PROXY_H
